;Boris Diplomat 3870 labeled M SC80265P 007-7024-00 7847 - Motorola
;code originates at $5000 - alias for $0000 since only 11 bit address bus (=2K, or $0800 bytes)

;ports 4 and 5 connect to 2 2112-1 static RAM chips, giving 256 bytes of RAM
;8-digit 7-segment LED display, 4x4 keypad matrix
;2 75491 LED drivers and 2 75492 LED drivers for LED display and keypad
;MC14028B binary to octal decoder 3 inputs 8 outputs

;3870 Port assignment summary					
;port 0 2:0 = octal decoder for 8 LED digits and 4 keypad rows
;port 0 3 = N/C
;port 0 7:4 = keypad columns
;port 1 7 = N/C
;port 1 6:0 = LED segments xGFEDCBA
;port 4 7:0 = RAM data
;port 5 7:0 = RAM addr
;strobe = RAM R/W

;keyboard matrix				
;         Port0-4   Port0-5   Port0-6   Port0-7
;octal 4   G/7        H/8        9        CE
;octal 5   D/4        E/5       F/6      TIME
;octal 6   A/1        B/2       C/3      RANK
;octal 7    0          -        B/W      ENTER

;LED digits 76543210
;octal 0 = rightmost
;octal 7 = leftmost

;reset key to 3870 reset line

;timer interrupt used - outs 6 and 7 set it up; vector at $5020

;to do
;look for jump tables

org $5000

                LIS  $0                  ; 5000 70
                OUTS 5                   ; 5001 b5			;RAM addr
                INS  5                   ; 5002 a5			;RAM addr
                BF   $4,A5048            ; 5003 94 44			;is this some kind of diagnostic?  warm boot flag?

;init board
                DCI  A5581               ; 5005 2a 55 81		;piece locations and square values
A5008:          LR   IS,A                ; 5008 0b
                LM                       ; 5009 16
                SR   4                   ; 500a 14
                AI   $f8                 ; 500b 24 f8		;mask off the piece
                OUTS 4                   ; 500d b4		;RAM data
                LIS  $0                  ; 500e 70
                LR   (IS),A              ; 500f 5c
                INS  5                   ; 5010 a5			;RAM addr
                INC                      ; 5011 1f
                BR7  A5016               ; 5012 8f 03
                AI   $08                 ; 5014 24 08
A5016:          OUTS 5                   ; 5016 b5			;RAM addr
                LR   A,IS                ; 5017 0a
                AI   $c1                 ; 5018 24 c1
                BF   $2,A5008            ; 501a 92 ed
                OUTS 4                   ; 501c b4		;RAM data
                JMP  A5240               ; 501d 29 52 40

                LR   (IS)-,A             ; 5020 5e		;timer interrupt vector
                LR   A,$b                ; 5021 4b
                LR   (IS)-,A             ; 5022 5e
                LR   A,$a                ; 5023 4a
                LR   (IS)-,A             ; 5024 5e
                LR   A,$9                ; 5025 49
                LR   (IS),A              ; 5026 5c
                LR   J,W                 ; 5027 1e
                LR   A,IS                ; 5028 0a
                SL   1                   ; 5029 13
                SL   1                   ; 502a 13
                XS   $9                  ; 502b e9
                LR   $9,A                ; 502c 59
                XDC                      ; 502d 2c
                INS  5                   ; 502e a5			;RAM addr
                LR   $a,A                ; 502f 5a
                LISU 2                   ; 5030 62
                INS  0                   ; 5031 a0
                INC                      ; 5032 1f
                NI   $07                 ; 5033 21 07
                LR   $b,A                ; 5035 5b
                LIS  $3                  ; 5036 73
                NS   $7                  ; 5037 f7
                BT   4,A5050             ; 5038 84 17
                CI   $02                 ; 503a 25 02
                BF   $2,A507c            ; 503c 92 3f
                BF   $4,A504b            ; 503e 94 0c
                DS   $b                  ; 5040 3b
                BT   2,A506f             ; 5041 82 2d
                LR   A,$6                ; 5043 46
A5044:          SR   4                   ; 5044 14
                INC                      ; 5045 1f
                BF   $0,A50a3            ; 5046 90 5c		;bra

A5048:          JMP  A5557               ; 5048 29 55 57

A504b:          LIS  $7                  ; 504b 77
                NS   $6                  ; 504c f6
                XS   $b                  ; 504d eb
                BT   4,A508a             ; 504e 84 3b
A5050:          LR   A,$6                ; 5050 46
                NI   $f0                 ; 5051 21 f0
                BT   1,A509e             ; 5053 81 4a
                LISL 0                   ; 5055 68
                SL   1                   ; 5056 13
                BF   $4,A507d            ; 5057 94 25
                XS   $0                  ; 5059 e0
                BF   $1,A5060            ; 505a 91 05
                XS   $7                  ; 505c e7
                LIS  $0                  ; 505d 70
                BF   $1,A50a1            ; 505e 91 42
A5060:          LISL 6                   ; 5060 6e
                LR   A,$b                ; 5061 4b
                CI   $01                 ; 5062 25 01
                BT   2,A5095             ; 5064 82 30
                AI   $fd                 ; 5066 24 fd
                BF   $1,A508a            ; 5068 91 21
                LISL 7                   ; 506a 6f
                CI   $01                 ; 506b 25 01
                BT   2,A5095             ; 506d 82 27
A506f:          XI   $02                 ; 506f 23 02
                BT   4,A50a1             ; 5071 84 2f
                XS   $0                  ; 5073 e0
                BT   1,A507c             ; 5074 81 07
                LR   A,$5                ; 5076 45
                AS   $b                  ; 5077 cb
                AI   $86                 ; 5078 24 86
                BT   1,A50a3             ; 507a 81 28
A507c:          LISL 1                   ; 507c 69
A507d:          LR   A,$b                ; 507d 4b
A507e:          CI   $01                 ; 507e 25 01
                BT   2,A508e             ; 5080 82 0d
                XS   (IS)                ; 5082 ec
                XS   (IS)+               ; 5083 ed
                XS   (IS)                ; 5084 ec
                XS   (IS)+               ; 5085 ed
                AI   $fd                 ; 5086 24 fd
                BT   1,A507e             ; 5088 81 f5
A508a:          LIS  $b                  ; 508a 7b
                AS   $1                  ; 508b c1
                BF   $0,A50a3            ; 508c 90 16		;bra

A508e:          LR   A,(IS)              ; 508e 4c
                BF   $4,A5092            ; 508f 94 02
                SL   4                   ; 5091 15
A5092:          SR   4                   ; 5092 14
                BF   $0,A50a3            ; 5093 90 0f		;bra

A5095:          LR   A,(IS)              ; 5095 4c
                BT   4,A5044             ; 5096 84 ad
                NI   $0f                 ; 5098 21 0f
                AI   $15                 ; 509a 24 15
                BF   $0,A50a3            ; 509c 90 06		;bra

A509e:          AS   $b                  ; 509e cb
                OUTS 5                   ; 509f b5		;RAM addr

                INS  4                   ; 50a0 a4			;RAM data		(external interrupt vector, not used)
A50a1:          AI   $24                 ; 50a1 24 24
A50a3:          DCI  A57ab               ; 50a3 2a 57 ab	;LED segment table
                ADC                      ; 50a6 8e
                INS  0                   ; 50a7 a0
                INC                      ; 50a8 1f
                NI   $f7                 ; 50a9 21 f7
                OUTS 0                   ; 50ab b0
                LM                       ; 50ac 16
                OUTS 1                   ; 50ad b1		;LED segments
                LR   A,$a                ; 50ae 4a
                OUTS 5                   ; 50af b5		;RAM addr
                INS  0                   ; 50b0 a0
                LR   $a,A                ; 50b1 5a
                SR   4                   ; 50b2 14		;top 4 bits = keypad columns
                BT   4,A511b             ; 50b3 84 67		;skip if no keys down
                LIS  $7                  ; 50b5 77		;mask low 3
                NS   $a                  ; 50b6 fa
                OUTS 0                   ; 50b7 b0
                LR   A,$a                ; 50b8 4a
                CI   $87                 ; 50b9 25 87
                BT   2,A50cf             ; 50bb 82 13
                INS  0                   ; 50bd a0
                CI   $07                 ; 50be 25 07
                BF   $2,A50d5            ; 50c0 92 14
                LR   A,$a                ; 50c2 4a
                BF   $4,A50d7            ; 50c3 94 13
                CI   $c7                 ; 50c5 25 c7
                LI   $c7                 ; 50c7 20 c7
                BF   $2,A50d7            ; 50c9 92 0d
                LR   A,$7                ; 50cb 47
                NI   $fc                 ; 50cc 21 fc
                LR   $7,A                ; 50ce 57
A50cf:          INS  0                   ; 50cf a0
                CI   $07                 ; 50d0 25 07
                BT   2,A511b             ; 50d2 82 48
                LR   $a,A                ; 50d4 5a
A50d5:          OI   $e0                 ; 50d5 22 e0
A50d7:          OUTS 0                   ; 50d7 b0
                LR   A,$a                ; 50d8 4a
                CI   $83                 ; 50d9 25 83
                BF   $2,A511b            ; 50db 92 3f
                LISL 0                   ; 50dd 68
                BF   $4,A5109            ; 50de 94 2a
                XS   $0                  ; 50e0 e0
                LI   $f0                 ; 50e1 20 f0
                BF   $1,A50fc            ; 50e3 91 18
                NS   $6                  ; 50e5 f6
                CI   $80                 ; 50e6 25 80
                BF   $2,A50fd            ; 50e8 92 14
                LR   $6,A                ; 50ea 56
                BT   4,A50f6             ; 50eb 84 0a
                OUTS 5                   ; 50ed b5		;RAM addr
A50ee:          LIS  $0                  ; 50ee 70
                OUTS 4                   ; 50ef b4		;RAM data
                INS  5                   ; 50f0 a5			;RAM addr
                INC                      ; 50f1 1f
                OUTS 5                   ; 50f2 b5		;RAM addr
                SL   4                   ; 50f3 15
                BT   1,A50ee             ; 50f4 81 f9
A50f6:          LISL 6                   ; 50f6 6e
                LIS  $0                  ; 50f7 70
                LR   $5,A                ; 50f8 55
                COM                      ; 50f9 18
                LR   (IS)+,A             ; 50fa 5d
                LR   (IS),A              ; 50fb 5c
A50fc:          NS   $6                  ; 50fc f6
A50fd:          XI   $90                 ; 50fd 23 90
                BF   $4,A511b            ; 50ff 94 1b
                LR   (IS),A              ; 5101 5c
                LISL 2                   ; 5102 6a
                LR   (IS),A              ; 5103 5c
                LISL 4                   ; 5104 6c
                LR   (IS),A              ; 5105 5c
A5106:          LIS  $9                  ; 5106 79
                BF   $0,A5131            ; 5107 90 29		;bra

A5109:          CI   $81                 ; 5109 25 81
                BF   $2,A515e            ; 510b 92 52
                BF   $4,A511e            ; 510d 94 10
                LR   A,$6                ; 510f 46
                NI   $f8                 ; 5110 21 f8
                BT   1,A5116             ; 5112 81 03
                OI   $f0                 ; 5114 22 f0
A5116:          AI   $10                 ; 5116 24 10
                LR   $6,A                ; 5118 56
                BT   1,A515d             ; 5119 81 43
A511b:          JMP  A51fa               ; 511b 29 51 fa	;no keys down

A511e:          SL   1                   ; 511e 13
                BF   $4,A5163            ; 511f 94 43
                XS   $6                  ; 5121 e6
                BT   1,A5130             ; 5122 81 0d
                SR   4                   ; 5124 14
                CI   $09                 ; 5125 25 09
                BF   $4,A5137            ; 5127 94 0f
                LISL 0                   ; 5129 68
                LR   A,(IS)+             ; 512a 4d
                LR   (IS)+,A             ; 512b 5d
                LR   A,(IS)+             ; 512c 4d
                LR   (IS)+,A             ; 512d 5d
                LR   A,(IS)+             ; 512e 4d
                LR   (IS),A              ; 512f 5c
A5130:          LIS  $8                  ; 5130 78
A5131:          SL   4                   ; 5131 15
                XS   $6                  ; 5132 e6
                NI   $f7                 ; 5133 21 f7
                XS   $6                  ; 5135 e6
                LR   $6,A                ; 5136 56
A5137:          BF   $2,A511b            ; 5137 92 e3
                SL   4                   ; 5139 15
                LR   $6,A                ; 513a 56
                XS   $0                  ; 513b e0
                BF   $1,A511b            ; 513c 91 de
                LI   $a0                 ; 513e 20 a0
                OUTS 5                   ; 5140 b5		;RAM addr
                LR   A,$7                ; 5141 47
                SR   1                   ; 5142 12
                SR   1                   ; 5143 12
                OUTS 4                   ; 5144 b4		;RAM data
                LIS  $f                  ; 5145 7f
                OUTS 5                   ; 5146 b5		;RAM addr
                LIS  $0                  ; 5147 70
                OUTS 4                   ; 5148 b4		;RAM data
                LISL 6                   ; 5149 6e
                LR   A,(IS)+             ; 514a 4d
                NS   (IS)-               ; 514b fe
                COM                      ; 514c 18
A514d:          LI   $77                 ; 514d 20 77
                BT   4,A51a8             ; 514f 84 58
                LISU 7                   ; 5151 67
                LISL 3                   ; 5152 6b
                JMP  A533b               ; 5153 29 53 3b

A5156:          XS   $0                  ; 5156 e0
                BT   1,A515c             ; 5157 81 04
                LR   A,$1                ; 5159 41
                COM                      ; 515a 18
                LR   $1,A                ; 515b 51
A515c:          DS   $7                  ; 515c 37
A515d:          DS   $7                  ; 515d 37
A515e:          LIS  $3                  ; 515e 73
                AS   $7                  ; 515f c7
                LR   $7,A                ; 5160 57
                BF   $0,A511b            ; 5161 90 b9		;bra

A5163:          CI   $40                 ; 5163 25 40
                BT   4,A51cd             ; 5165 84 67
                AS   $a                  ; 5167 ca
                AI   $40                 ; 5168 24 40
                BT   4,A5156             ; 516a 84 eb
                BT   2,A5177             ; 516c 82 0a
                AI   $5f                 ; 516e 24 5f
                BT   2,A5177             ; 5170 82 06
                AI   $2f                 ; 5172 24 2f
                BT   2,A5177             ; 5174 82 02
                LIS  $0                  ; 5176 70
A5177:          LR   $a,A                ; 5177 5a
                LR   A,$6                ; 5178 46
                CI   $8f                 ; 5179 25 8f
                BF   $2,A51d2            ; 517b 92 56
                LIS  $9                  ; 517d 79
                XS   $a                  ; 517e ea
                BT   4,A5106             ; 517f 84 86
                XS   $0                  ; 5181 e0
                BT   1,A51fa             ; 5182 81 77
                LISL 6                   ; 5184 6e
                LR   A,$6                ; 5185 46
                NI   $f7                 ; 5186 21 f7
                BF   $1,A519f            ; 5188 91 16
                LR   $6,A                ; 518a 56
                OUTS 5                   ; 518b b5		;RAM addr
                LR   A,$a                ; 518c 4a
                CI   $06                 ; 518d 25 06
                BF   $2,A51fa            ; 518f 92 6a
                AS   $1                  ; 5191 c1
                XS   $1                  ; 5192 e1
                COM                      ; 5193 18
                INC                      ; 5194 1f
                OUTS 4                   ; 5195 b4		;RAM data
                LIS  $f                  ; 5196 7f
                OUTS 5                   ; 5197 b5		;RAM addr
                LIS  $0                  ; 5198 70
                OUTS 4                   ; 5199 b4		;RAM data
                LR   $5,A                ; 519a 55
                COM                      ; 519b 18
                LR   (IS)+,A             ; 519c 5d
                BF   $0,A51e4            ; 519d 90 46		;bra

A519f:          DS   $a                  ; 519f 3a
                BF   $2,A51fa            ; 51a0 92 59
                XS   $6                  ; 51a2 e6
                BT   4,A51bb             ; 51a3 84 17
                LR   A,$a                ; 51a5 4a
                LR   $6,A                ; 51a6 56
                LR   A,$0                ; 51a7 40
A51a8:          LR   $0,A                ; 51a8 50
                LR   A,(IS)+             ; 51a9 4d
                LR   $a,A                ; 51aa 5a
                LR   A,(IS)              ; 51ab 4c
                LR   $b,A                ; 51ac 5b
                JMP  A52c3               ; 51ad 29 52 c3

A51b0:          LISU 2                   ; 51b0 62
                LISL 6                   ; 51b1 6e
                LR   A,$6                ; 51b2 46
                LR   $a,A                ; 51b3 5a
                LI   $ff                 ; 51b4 20 ff
                LR   (IS)+,A             ; 51b6 5d
                LR   (IS)-,A             ; 51b7 5e
                LI   $80                 ; 51b8 20 80
                LR   $6,A                ; 51ba 56
A51bb:          LR   A,$6                ; 51bb 46
                CI   $81                 ; 51bc 25 81
                BT   2,A51c5             ; 51be 82 06
                CI   $84                 ; 51c0 25 84
                BF   $2,A51e5            ; 51c2 92 22
                LISL 7                   ; 51c4 6f
A51c5:          BF   $4,A51e0            ; 51c5 94 1a
                LR   A,$a                ; 51c7 4a
                SL   4                   ; 51c8 15
                LR   $a,A                ; 51c9 5a
                LIS  $f                  ; 51ca 7f
                BF   $0,A51e2            ; 51cb 90 16		;bra

A51cd:          LIS  $1                  ; 51cd 71
                AS   $7                  ; 51ce c7
                LR   $7,A                ; 51cf 57
                BF   $0,A51e5            ; 51d0 90 14		;bra

A51d2:          LISL 5                   ; 51d2 6d
A51d3:          LR   A,(IS)-             ; 51d3 4e
                LR   A,(IS)              ; 51d4 4c
                LR   $b,A                ; 51d5 5b
                SL   4                   ; 51d6 15
                AS   $a                  ; 51d7 ca
                LR   (IS)-,A             ; 51d8 5e
                LR   A,$b                ; 51d9 4b
                SR   4                   ; 51da 14
                LR   $a,A                ; 51db 5a
                BR7  A51d3               ; 51dc 8f f6
                BF   $0,A51fa            ; 51de 90 1b		;bra

A51e0:          LI   $f0                 ; 51e0 20 f0
A51e2:          NS   (IS)                ; 51e2 fc
                AS   $a                  ; 51e3 ca
A51e4:          LR   (IS),A              ; 51e4 5c
A51e5:          LIS  $7                  ; 51e5 77
                NS   $6                  ; 51e6 f6
                CI   $07                 ; 51e7 25 07
                LIS  $1                  ; 51e9 71
                BF   $4,A51ee            ; 51ea 94 03
                LI   $f9                 ; 51ec 20 f9
A51ee:          AS   $6                  ; 51ee c6
                LR   $6,A                ; 51ef 56
                NI   $87                 ; 51f0 21 87
                CI   $82                 ; 51f2 25 82
                BT   4,A51e5             ; 51f4 84 f0
                CI   $85                 ; 51f6 25 85
                BT   4,A51e5             ; 51f8 84 ec
A51fa:          INS  0                   ; 51fa a0
                INC                      ; 51fb 1f
                SL   4                   ; 51fc 15
                BT   1,A522f             ; 51fd 81 31
                LIS  $4                  ; 51ff 74
                AS   $7                  ; 5200 c7
                LR   $7,A                ; 5201 57
                BF   $2,A522f            ; 5202 92 2c
                AI   $38                 ; 5204 24 38
                LR   $7,A                ; 5206 57
                LISL 5                   ; 5207 6d
A5208:          LI   $ff                 ; 5208 20 ff
                ASD  (IS)                ; 520a dc
                BT   2,A522e             ; 520b 82 22
                LI   $59                 ; 520d 20 59
                LR   (IS)-,A             ; 520f 5e
                LR   A,(IS)-             ; 5210 4e
                BR7  A5208               ; 5211 8f f6
                LR   A,$0                ; 5213 40
                NI   $3f                 ; 5214 21 3f
                XI   $37                 ; 5216 23 37
                BT   4,A5229             ; 5218 84 10
                LR   A,$9                ; 521a 49
                SR   1                   ; 521b 12
                SR   1                   ; 521c 12
                OI   $c3                 ; 521d 22 c3
                LR   IS,A                ; 521f 0b
                LR   $0,A                ; 5220 50
A5221:          LR   A,IS                ; 5221 0a
                CI   $3b                 ; 5222 25 3b
                BT   4,A5274             ; 5224 84 4f
                JMP  A547e               ; 5226 29 54 7e

A5229:          LISL 1                   ; 5229 69
                LR   (IS),A              ; 522a 5c
                LISL 3                   ; 522b 6b
                LR   (IS),A              ; 522c 5c
                LISL 5                   ; 522d 6d
A522e:          LR   (IS),A              ; 522e 5c
A522f:          XDC                      ; 522f 2c
                LR   A,$9                ; 5230 49
                SR   4                   ; 5231 14
                SL   1                   ; 5232 13
                SL   1                   ; 5233 13
                LR   IS,A                ; 5234 0b
                LR   W,J                 ; 5235 1d
                DI                       ; 5236 1a
                LR   A,(IS)+             ; 5237 4d
                LR   $9,A                ; 5238 59
                LR   A,(IS)+             ; 5239 4d
                LR   $a,A                ; 523a 5a
                LR   A,(IS)+             ; 523b 4d
                LR   $b,A                ; 523c 5b
                LR   A,(IS)              ; 523d 4c
                EI                       ; 523e 1b
                POP                      ; 523f 1c

A5240:          DS   $1                  ; 5240 31
                LI   $8a                 ; 5241 20 8a		;10001010 = /20 prescaler, start, enable timer int
                OUTS 6                   ; 5243 b6		;interrupt control reg
                LI   $bb                 ; 5244 20 bb
                OUTS 7                   ; 5246 b7		;timer
A5247:          LISU 2                   ; 5247 62
                LISL 6                   ; 5248 6e
                LI   $ff                 ; 5249 20 ff
                LR   (IS)+,A             ; 524b 5d
                LR   (IS),A              ; 524c 5c
A524d:          LI   $80                 ; 524d 20 80
                BF   $0,A525e            ; 524f 90 0e		;bra

A5251:          LIS  $7                  ; 5251 77
                XS   $5                  ; 5252 e5
                LR   $5,A                ; 5253 55
A5254:          LISU 2                   ; 5254 62
                LISL 0                   ; 5255 68
                LR   A,(IS)+             ; 5256 4d
                LR   (IS)+,A             ; 5257 5d
                LR   A,(IS)+             ; 5258 4d
                LR   (IS)+,A             ; 5259 5d
                LR   A,(IS)+             ; 525a 4d
                LR   (IS),A              ; 525b 5c
                LI   $88                 ; 525c 20 88
A525e:          LR   $6,A                ; 525e 56
                LI   $56                 ; 525f 20 56
                LR   KU,A                ; 5261 04
                LR   QU,A                ; 5262 06
                LI   $f7                 ; 5263 20 f7
                LR   $0,A                ; 5265 50
                EI                       ; 5266 1b
                LR   IS,A                ; 5267 0b
A5268:          BF   $0,A5268            ; 5268 90 ff		;bra - wait here for interrupt

A526a:          DI                       ; 526a 1a
                LR   A,$2                ; 526b 42
                SL   1                   ; 526c 13
                AI   $85                 ; 526d 24 85
                LR   $5,A                ; 526f 55
                LR   A,$2                ; 5270 42
                SR   1                   ; 5271 12
                BT   4,A5247             ; 5272 84 d4
A5274:          LIS  $7                  ; 5274 77
                LR   A,$8                ; 5275 48
                INC                      ; 5276 1f
                LR   $9,A                ; 5277 59
                LI   $a0                 ; 5278 20 a0
                OUTS 5                   ; 527a b5		;RAM addr
                INS  4                   ; 527b a4			;RAM data
A527c:          AS   $9                  ; 527c c9
                BF   $2,A527c            ; 527d 92 fe
                SL   1                   ; 527f 13
                AI   $80                 ; 5280 24 80
                OUTS 5                   ; 5282 b5		;RAM addr
                LISU 2                   ; 5283 62
                LISL 6                   ; 5284 6e
                INS  4                   ; 5285 a4			;RAM data
                LR   $9,A                ; 5286 59
                NI   $77                 ; 5287 21 77
                LR   (IS)+,A             ; 5289 5d
                LR   $a,A                ; 528a 5a
                INS  5                   ; 528b a5			;RAM addr
                INC                      ; 528c 1f
                OUTS 5                   ; 528d b5		;RAM addr
                INS  4                   ; 528e a4			;RAM data
                LR   (IS)-,A             ; 528f 5e
                LR   $b,A                ; 5290 5b
                LI   $80                 ; 5291 20 80
                OUTS 5                   ; 5293 b5		;RAM addr
                LR   A,$9                ; 5294 49
                OUTS 4                   ; 5295 b4		;RAM data
                NI   $80                 ; 5296 21 80
                LR   $5,A                ; 5298 55
                INS  5                   ; 5299 a5			;RAM addr
                INC                      ; 529a 1f
                OUTS 5                   ; 529b b5		;RAM addr
                LR   A,$b                ; 529c 4b
                OUTS 4                   ; 529d b4		;RAM data
                LIS  $f                  ; 529e 7f
                OUTS 5                   ; 529f b5		;RAM addr
                LIS  $0                  ; 52a0 70
                OUTS 4                   ; 52a1 b4		;RAM data
                LR   A,$0                ; 52a2 40
                OI   $40                 ; 52a3 22 40
                BF   $1,A5254            ; 52a5 91 ae
                CI   $5b                 ; 52a7 25 5b
                BT   2,A5254             ; 52a9 82 aa
                AI   $fc                 ; 52ab 24 fc
                LR   $0,A                ; 52ad 50
                LR   A,$2                ; 52ae 42
                INC                      ; 52af 1f
                BT   4,A5251             ; 52b0 84 a0
                INC                      ; 52b2 1f
                CI   $04                 ; 52b3 25 04
                BT   2,A5254             ; 52b5 82 9e
                LR   A,$a                ; 52b7 4a
                OUTS 5                   ; 52b8 b5		;RAM addr
                INS  4                   ; 52b9 a4			;RAM data
                AI   $fe                 ; 52ba 24 fe
                CI   $fc                 ; 52bc 25 fc
                LI   $59                 ; 52be 20 59
                LNK                      ; 52c0 19
                LR   KL,A                ; 52c1 05
                LISL 3                   ; 52c2 6b
A52c3:          LISU 7                   ; 52c3 67
                LIS  $0                  ; 52c4 70
                LR   $2,A                ; 52c5 52
A52c6:          LR   A,$a                ; 52c6 4a
                OUTS 5                   ; 52c7 b5		;RAM addr
                INS  4                   ; 52c8 a4			;RAM data
                LR   $4,A                ; 52c9 54
                LIS  $0                  ; 52ca 70
                DI                       ; 52cb 1a
                OUTS 4                   ; 52cc b4		;RAM data
                LR   A,KL                ; 52cd 01
                LR   (IS)-,A             ; 52ce 5e
                LR   A,$2                ; 52cf 42
                LR   (IS)-,A             ; 52d0 5e
                LR   A,$b                ; 52d1 4b
                OUTS 5                   ; 52d2 b5		;RAM addr
                INS  4                   ; 52d3 a4			;RAM data
                AS   $1                  ; 52d4 c1
                XS   $1                  ; 52d5 e1
                SL   4                   ; 52d6 15
                LR   $5,A                ; 52d7 55
                SR   1                   ; 52d8 12
                SR   1                   ; 52d9 12
                XS   $5                  ; 52da e5
                LR   $5,A                ; 52db 55
                SL   1                   ; 52dc 13
                NI   $88                 ; 52dd 21 88
                XS   $b                  ; 52df eb
                LR   (IS)-,A             ; 52e0 5e
                LIS  $8                  ; 52e1 78
                NS   $5                  ; 52e2 f5
                XS   $a                  ; 52e3 ea
                LR   (IS),A              ; 52e4 5c
                LR   A,IS                ; 52e5 0a
                AI   $ff                 ; 52e6 24 ff
                LR   IS,A                ; 52e8 0b
                LR   A,$1                ; 52e9 41
                COM                      ; 52ea 18
                LR   $1,A                ; 52eb 51
                AS   $4                  ; 52ec c4
                XS   $1                  ; 52ed e1
                SR   1                   ; 52ee 12
                LR   A,$4                ; 52ef 44
                BF   $4,A52fc            ; 52f0 94 0b
                SR   1                   ; 52f2 12
                XS   $b                  ; 52f3 eb
                SR   4                   ; 52f4 14
                CI   $07                 ; 52f5 25 07
                LR   A,$4                ; 52f7 44
                BF   $4,A531f            ; 52f8 94 26
                XI   $04                 ; 52fa 23 04
A52fc:          OUTS 4                   ; 52fc b4		;RAM data
                AS   $1                  ; 52fd c1
                XS   $1                  ; 52fe e1
A52ff:          CI   $06                 ; 52ff 25 06
                LIS  $f                  ; 5301 7f
                OUTS 5                   ; 5302 b5		;RAM addr
                BF   $4,A532e            ; 5303 94 2a
                LR   A,$a                ; 5305 4a
                XS   $b                  ; 5306 eb
                NI   $7b                 ; 5307 21 7b
                CI   $02                 ; 5309 25 02
                BF   $4,A532e            ; 530b 94 22
                LIS  $4                  ; 530d 74
                NS   $b                  ; 530e fb
                SR   1                   ; 530f 12
                DS   $a                  ; 5310 3a
                AS   $a                  ; 5311 ca
                OUTS 5                   ; 5312 b5		;RAM addr
                LIS  $4                  ; 5313 74
                AS   $1                  ; 5314 c1
                XS   $1                  ; 5315 e1
                OUTS 4                   ; 5316 b4		;RAM data
                LIS  $4                  ; 5317 74
                NS   $b                  ; 5318 fb
                LIS  $1                  ; 5319 71
                BF   $4,A532c            ; 531a 94 11
                LIS  $2                  ; 531c 72
                BF   $0,A532a            ; 531d 90 0c		;bra

A531f:          OUTS 4                   ; 531f b4		;RAM data
                DS   $5                  ; 5320 35
                BT   2,A52ff             ; 5321 82 dd
                LR   A,$a                ; 5323 4a
                XS   $b                  ; 5324 eb
                SL   4                   ; 5325 15
                LR   A,$4                ; 5326 44
                BT   4,A52ff             ; 5327 84 d7
                SL   4                   ; 5329 15
A532a:          COM                      ; 532a 18
                INC                      ; 532b 1f
A532c:          AS   $b                  ; 532c cb
                OUTS 5                   ; 532d b5		;RAM addr
A532e:          LIS  $0                  ; 532e 70
                OUTS 4                   ; 532f b4		;RAM data
                LR   A,$0                ; 5330 40
                OI   $40                 ; 5331 22 40
                BT   1,A5338             ; 5333 81 04
                JMP  A51b0               ; 5335 29 51 b0

A5338:          LR   $0,A                ; 5338 50
                LIS  $0                  ; 5339 70
                LR   $2,A                ; 533a 52
A533b:          EI                       ; 533b 1b
                LI   $d1                 ; 533c 20 d1
                LR   KL,A                ; 533e 05
                LIS  $8                  ; 533f 78
A5340:          OUTS 5                   ; 5340 b5		;RAM addr
                LIS  $0                  ; 5341 70
                OUTS 4                   ; 5342 b4		;RAM data
                INS  5                   ; 5343 a5			;RAM addr
                INC                      ; 5344 1f
                OI   $08                 ; 5345 22 08
                BT   1,A5340             ; 5347 81 f8
A5349:          LI   $f7                 ; 5349 20 f7
                LR   $a,A                ; 534b 5a
A534c:          LIS  $9                  ; 534c 79
                AS   $a                  ; 534d ca
                BF   $1,A536d            ; 534e 91 1e
                NI   $77                 ; 5350 21 77
                LR   $a,A                ; 5352 5a
                OUTS 5                   ; 5353 b5		;RAM addr
                INS  4                   ; 5354 a4			;RAM data
                BT   4,A534c             ; 5355 84 f6
                XS   $1                  ; 5357 e1
                BF   $1,A535e            ; 5358 91 05
                LR   A,$0                ; 535a 40
                SL   1                   ; 535b 13
                BT   1,A534c             ; 535c 81 ef
A535e:          LR   A,$a                ; 535e 4a
                LR   $b,A                ; 535f 5b
                INS  4                   ; 5360 a4			;RAM data
                LR   $4,A                ; 5361 54
                SL   1                   ; 5362 13
                DCI  A579d               ; 5363 2a 57 9d	;jump table w/data
                ADC                      ; 5366 8e
                LM                       ; 5367 16
                LR   QL,A                ; 5368 07		;QH has $56
                LM                       ; 5369 16
                LR   $3,A                ; 536a 53
                LR   $9,A                ; 536b 59
                LR   P0,Q                ; 536c 0d

A536d:          LR   A,$0                ; 536d 40
                XI   $40                 ; 536e 23 40
                LR   $0,A                ; 5370 50
                LR   A,IS                ; 5371 0a
                XS   $0                  ; 5372 e0
                BT   4,A53c9             ; 5373 84 55
                SL   1                   ; 5375 13
                BT   1,A537b             ; 5376 81 04
                JMP  A545f               ; 5378 29 54 5f

A537b:          LR   A,$0                ; 537b 40
                CI   $37                 ; 537c 25 37
                BF   $4,A538b            ; 537e 94 0c
                DI                       ; 5380 1a
                LISU 2                   ; 5381 62
                LISL 0                   ; 5382 68
                LR   A,(IS)+             ; 5383 4d
                LR   (IS)+,A             ; 5384 5d
                LR   A,(IS)+             ; 5385 4d
                LR   (IS)+,A             ; 5386 5d
                LR   A,(IS)+             ; 5387 4d
                LR   (IS),A              ; 5388 5c
                LISU 7                   ; 5389 67
                LISL 3                   ; 538a 6b
A538b:          LIS  $1                  ; 538b 71
                LR   $4,A                ; 538c 54
                LR   $5,A                ; 538d 55
                LIS  $c                  ; 538e 7c
                XS   $1                  ; 538f e1
                SL   4                   ; 5390 15
                LR   $3,A                ; 5391 53
A5392:          LR   A,$1                ; 5392 41
                NI   $70                 ; 5393 21 70
                XI   $74                 ; 5395 23 74
                LR   $a,A                ; 5397 5a
                LR   $b,A                ; 5398 5b
                OUTS 5                   ; 5399 b5		;RAM addr
                LIS  $6                  ; 539a 76
                AS   $1                  ; 539b c1
                XS   $1                  ; 539c e1
                LR   $9,A                ; 539d 59
A539e:          INS  4                   ; 539e a4			;RAM data
                AS   $9                  ; 539f c9
                BF   $4,A53c2            ; 53a0 94 21
                LR   $9,A                ; 53a2 59
                INS  5                   ; 53a3 a5			;RAM addr
                LR   QL,A                ; 53a4 07
                NI   $06                 ; 53a5 21 06
                BT   4,A53b1             ; 53a7 84 09
                LR   A,QL                ; 53a9 03
                AI   $08                 ; 53aa 24 08
                OUTS 5                   ; 53ac b5		;RAM addr
                INS  4                   ; 53ad a4			;RAM data
                NS   $3                  ; 53ae f3
                BF   $4,A53c2            ; 53af 94 12
A53b1:          LR   A,QL                ; 53b1 03
                AS   $5                  ; 53b2 c5
                OUTS 5                   ; 53b3 b5		;RAM addr
                AS   $5                  ; 53b4 c5
                SL   4                   ; 53b5 15
                BT   1,A539e             ; 53b6 81 e7
                INS  4                   ; 53b8 a4			;RAM data
                AS   $1                  ; 53b9 c1
                XS   $1                  ; 53ba e1
                CI   $fc                 ; 53bb 25 fc
                BF   $4,A53c2            ; 53bd 94 04
                LR   A,$4                ; 53bf 44
                XS   $5                  ; 53c0 e5
                LR   $4,A                ; 53c1 54
A53c2:          DS   $5                  ; 53c2 35
                DS   $5                  ; 53c3 35
                BF   $2,A5392            ; 53c4 92 cd
                JMP  A5682               ; 53c6 29 56 82

A53c9:          LR   $a,A                ; 53c9 5a
                LR   $3,A                ; 53ca 53
                LI   $f7                 ; 53cb 20 f7
                LR   $2,A                ; 53cd 52
                LI   $82                 ; 53ce 20 82
                LR   $9,A                ; 53d0 59
A53d1:          LIS  $7                  ; 53d1 77
                NS   $a                  ; 53d2 fa
                AS   $a                  ; 53d3 ca
                SR   1                   ; 53d4 12
                DCI  A5581               ; 53d5 2a 55 81
                ADC                      ; 53d8 8e
                LIS  $f                  ; 53d9 7f
                NM                       ; 53da 8a
                LR   $b,A                ; 53db 5b
                LIS  $8                  ; 53dc 78
                AS   $a                  ; 53dd ca
                OUTS 5                   ; 53de b5		;RAM addr
                INS  4                   ; 53df a4			;RAM data
                LR   QL,A                ; 53e0 07
                SR   4                   ; 53e1 14
                DCI  A55c1               ; 53e2 2a 55 c1
                ADC                      ; 53e5 8e
                LR   A,QL                ; 53e6 03
                AM                       ; 53e7 88
                BT   1,A53eb             ; 53e8 81 02
                SR   4                   ; 53ea 14
A53eb:          ADC                      ; 53eb 8e
                LM                       ; 53ec 16
                LR   QL,A                ; 53ed 07
                SR   4                   ; 53ee 14
                COM                      ; 53ef 18
                INC                      ; 53f0 1f
                LR   $5,A                ; 53f1 55
                LR   A,QL                ; 53f2 03
                NI   $0f                 ; 53f3 21 0f
                AS   $5                  ; 53f5 c5
                LR   $5,A                ; 53f6 55
                LI   $80                 ; 53f7 20 80
A53f9:          AS   $5                  ; 53f9 c5
                DS   $b                  ; 53fa 3b
                BF   $4,A53f9            ; 53fb 94 fd
                AS   $3                  ; 53fd c3
                LR   $3,A                ; 53fe 53
                LR   A,$2                ; 53ff 42
                LNK                      ; 5400 19
                LR   $2,A                ; 5401 52
                LR   A,$a                ; 5402 4a
                OUTS 5                   ; 5403 b5		;RAM addr
                INS  4                   ; 5404 a4			;RAM data
                BT   4,A543a             ; 5405 84 34
                LR   $4,A                ; 5407 54
                INC                      ; 5408 1f
                CI   $02                 ; 5409 25 02
                BF   $2,A5412            ; 540b 92 06
                LR   A,$a                ; 540d 4a
                XS   $4                  ; 540e e4
                SR   4                   ; 540f 14		;move high nybble to low
                AI   $08                 ; 5410 24 08		;add 8
A5412:          DCI  A5779               ; 5412 2a 57 79
                ADC                      ; 5415 8e
                LM                       ; 5416 16		;read from table
                LR   $5,A                ; 5417 55
                AS   $2                  ; 5418 c2
                LR   $2,A                ; 5419 52
                LR   A,$5                ; 541a 45
                COM                      ; 541b 18
                BT   1,A5423             ; 541c 81 06
                INC                      ; 541e 1f
                LR   $5,A                ; 541f 55
                LR   A,QL                ; 5420 03
                SL   4                   ; 5421 15
                LR   QL,A                ; 5422 07
A5423:          LR   A,QL                ; 5423 03
                SR   4                   ; 5424 14
                AS   $5                  ; 5425 c5
                BT   1,A543a             ; 5426 81 13
                LR   $5,A                ; 5428 55
                XS   $4                  ; 5429 e4
                BF   $1,A5430            ; 542a 91 05
                LR   A,$5                ; 542c 45
                COM                      ; 542d 18
                INC                      ; 542e 1f
                LR   $5,A                ; 542f 55
A5430:          XS   $1                  ; 5430 e1
                LR   A,$5                ; 5431 45
                BT   1,A5437             ; 5432 81 04
                AS   $2                  ; 5434 c2
                LR   $2,A                ; 5435 52
                LIS  $0                  ; 5436 70
A5437:          SL   1                   ; 5437 13
                AS   $9                  ; 5438 c9
                LR   $9,A                ; 5439 59
A543a:          LIS  $9                  ; 543a 79
                AS   $a                  ; 543b ca
                NI   $f7                 ; 543c 21 f7
                LR   $a,A                ; 543e 5a
                BT   1,A53d1             ; 543f 81 91
                LR   A,$3                ; 5441 43
                SR   4                   ; 5442 14
                AS   $9                  ; 5443 c9
                LR   $9,A                ; 5444 59
                SR   4                   ; 5445 14
                AS   $2                  ; 5446 c2
                CI   $3d                 ; 5447 25 3d
                BT   2,A5452             ; 5449 82 08
                CI   $9e                 ; 544b 25 9e
                LI   $f8                 ; 544d 20 f8
                BT   2,A5455             ; 544f 82 05
                LIS  $0                  ; 5451 70
A5452:          INC                      ; 5452 1f
                SL   1                   ; 5453 13
                SL   1                   ; 5454 13
A5455:          LR   $2,A                ; 5455 52
                LIS  $f                  ; 5456 7f
                NS   $9                  ; 5457 f9
                SR   1                   ; 5458 12
                SR   1                   ; 5459 12
                AS   $2                  ; 545a c2
                AS   $1                  ; 545b c1
                XS   $1                  ; 545c e1
                BF   $0,A547d            ; 545d 90 1f		;bra

A545f:          XS   $0                  ; 545f e0
                BF   $1,A546d            ; 5460 91 0c
A5462:          LR   A,IS                ; 5462 0a
                CI   $3b                 ; 5463 25 3b
                BF   $4,A5473            ; 5465 94 0d
                JMP  A526a               ; 5467 29 52 6a

A546a:          XS   $0                  ; 546a e0
                BT   1,A547e             ; 546b 81 12
A546d:          LI   $82                 ; 546d 20 82
                LR   $5,A                ; 546f 55
                JMP  A524d               ; 5470 29 52 4d

A5473:          LR   A,$2                ; 5473 42
                COM                      ; 5474 18
                INC                      ; 5475 1f
                BF   $4,A547a            ; 5476 94 03
                LI   $80                 ; 5478 20 80
A547a:          CI   $01                 ; 547a 25 01
                LNK                      ; 547c 19
A547d:          LR   $3,A                ; 547d 53
A547e:          LR   A,$1                ; 547e 41
                COM                      ; 547f 18
                LR   $1,A                ; 5480 51
                LR   A,IS                ; 5481 0a
                INC                      ; 5482 1f
                DI                       ; 5483 1a
                LR   IS,A                ; 5484 0b
                LR   A,(IS)              ; 5485 4c
                NI   $77                 ; 5486 21 77
                LR   $a,A                ; 5488 5a
                XS   (IS)+               ; 5489 ed
                LR   $5,A                ; 548a 55
                LR   A,(IS)              ; 548b 4c
                NI   $77                 ; 548c 21 77
                LR   $b,A                ; 548e 5b
                OUTS 5                   ; 548f b5		;RAM addr
                XS   (IS)+               ; 5490 ed
                SR   1                   ; 5491 12
                AS   $5                  ; 5492 c5
                LR   $5,A                ; 5493 55
                SL   1                   ; 5494 13
                SL   1                   ; 5495 13
                XS   $5                  ; 5496 e5
                SR   4                   ; 5497 14
                LR   $5,A                ; 5498 55
                INS  4                   ; 5499 a4			;RAM data
                LR   $4,A                ; 549a 54
                LR   A,(IS)+             ; 549b 4d
                LR   $2,A                ; 549c 52
                LR   A,(IS)              ; 549d 4c
                LR   KL,A                ; 549e 05
                CI   $59                 ; 549f 25 59
                BF   $2,A54ad            ; 54a1 92 0b
                LR   A,$4                ; 54a3 44
                XS   $b                  ; 54a4 eb
                COM                      ; 54a5 18
                NI   $70                 ; 54a6 21 70
                BF   $4,A54ad            ; 54a8 94 04
                LIS  $4                  ; 54aa 74
                XS   $4                  ; 54ab e4
                LR   $4,A                ; 54ac 54
A54ad:          LIS  $7                  ; 54ad 77
                NS   $5                  ; 54ae f5
                AS   $1                  ; 54af c1
                XS   $1                  ; 54b0 e1
                OUTS 4                   ; 54b1 b4		;RAM data
                BF   $4,A54c8            ; 54b2 94 15
                LR   A,$1                ; 54b4 41
                SL   1                   ; 54b5 13
                COM                      ; 54b6 18
                XS   $4                  ; 54b7 e4
                BF   $4,A54c8            ; 54b8 94 0f
                LR   A,$a                ; 54ba 4a
                XS   $b                  ; 54bb eb
                SL   4                   ; 54bc 15
                BT   4,A54c8             ; 54bd 84 0a
                LR   A,$4                ; 54bf 44
                COM                      ; 54c0 18
                INC                      ; 54c1 1f
                LR   QL,A                ; 54c2 07
                SL   4                   ; 54c3 15
                AS   $b                  ; 54c4 cb
                OUTS 5                   ; 54c5 b5		;RAM addr
                LR   A,QL                ; 54c6 03
                OUTS 4                   ; 54c7 b4		;RAM data
A54c8:          LR   A,$a                ; 54c8 4a
                OUTS 5                   ; 54c9 b5		;RAM addr
                LR   A,$4                ; 54ca 44
                OUTS 4                   ; 54cb b4		;RAM data
                LIS  $f                  ; 54cc 7f
                OUTS 5                   ; 54cd b5		;RAM addr
                LIS  $5                  ; 54ce 75
                AS   $4                  ; 54cf c4
                CI   $0a                 ; 54d0 25 0a
                BT   2,A54f6             ; 54d2 82 23
                LR   A,$a                ; 54d4 4a
                XS   $b                  ; 54d5 eb
                NI   $71                 ; 54d6 21 71
                BF   $4,A54f6            ; 54d8 94 1d
                LR   A,$3                ; 54da 43
                AI   $fd                 ; 54db 24 fd
                CI   $f9                 ; 54dd 25 f9
                LR   A,$3                ; 54df 43
                LNK                      ; 54e0 19
                LR   $3,A                ; 54e1 53
                LIS  $4                  ; 54e2 74
                NS   $b                  ; 54e3 fb
                LIS  $3                  ; 54e4 73
                BF   $4,A54e8            ; 54e5 94 02
                COM                      ; 54e7 18
A54e8:          AS   $a                  ; 54e8 ca
                OUTS 5                   ; 54e9 b5		;RAM addr
                LI   $fc                 ; 54ea 20 fc
                AS   $1                  ; 54ec c1
                XS   $1                  ; 54ed e1
                OUTS 4                   ; 54ee b4		;RAM data
                LIS  $4                  ; 54ef 74
                NS   $b                  ; 54f0 fb
                SR   1                   ; 54f1 12
                AI   $ff                 ; 54f2 24 ff
                AS   $a                  ; 54f4 ca
                OUTS 5                   ; 54f5 b5		;RAM addr
A54f6:          LIS  $0                  ; 54f6 70
                OUTS 4                   ; 54f7 b4		;RAM data
                LR   A,IS                ; 54f8 0a
                AI   $41                 ; 54f9 24 41
                BT   1,A5501             ; 54fb 81 05
                LR   $0,A                ; 54fd 50
                JMP  A546d               ; 54fe 29 54 6d

A5501:          LR   A,$0                ; 5501 40
                NI   $bf                 ; 5502 21 bf
                LR   $0,A                ; 5504 50
                BT   1,A550a             ; 5505 81 04
                JMP  A5221               ; 5507 29 52 21

A550a:          LR   A,$2                ; 550a 42
                COM                      ; 550b 18
                AS   $3                  ; 550c c3
                BF   $2,A5529            ; 550d 92 1b
                LR   A,$3                ; 550f 43
                LR   $2,A                ; 5510 52
                LR   A,IS                ; 5511 0a
                LR   $9,A                ; 5512 59
                XI   $3b                 ; 5513 23 3b
A5515:          BT   4,A5535             ; 5515 84 1f
                LIS  $3                  ; 5517 73
                AS   $9                  ; 5518 c9
A5519:          LR   IS,A                ; 5519 0b
A551a:          LR   A,(IS)              ; 551a 4c
                AS   $2                  ; 551b c2
A551c:          LR   A,$9                ; 551c 49
A551d:          LR   IS,A                ; 551d 0b
                BF   $2,A5550            ; 551e 92 31
                BF   $4,A5526            ; 5520 94 05
A5522:          CI   $37                 ; 5522 25 37
                BT   4,A5550             ; 5524 84 2b
A5526:          JMP  A5462               ; 5526 29 54 62

A5529:          INC                      ; 5529 1f
A552a:          BF   $4,A5550            ; 552a 94 25
                LR   A,IS                ; 552c 0a
A552d:          CI   $3b                 ; 552d 25 3b
                BF   $4,A5550            ; 552f 94 20
A5531:          LR   A,$8                ; 5531 48
A5532:          INC                      ; 5532 1f
                NI   $0f                 ; 5533 21 0f
A5535:          LR   $8,A                ; 5535 58
                SL   1                   ; 5536 13
                AI   $80                 ; 5537 24 80
                OUTS 5                   ; 5539 b5		;RAM addr
                LIS  $8                  ; 553a 78
                NS   $5                  ; 553b f5
                SL   4                   ; 553c 15
                LR   $9,A                ; 553d 59
                LISU 2                   ; 553e 62
                LISL 6                   ; 553f 6e
                LR   A,$a                ; 5540 4a
                LR   (IS)+,A             ; 5541 5d
                XS   $9                  ; 5542 e9
                OUTS 4                   ; 5543 b4		;RAM data
                INS  5                   ; 5544 a5			;RAM addr
                INC                      ; 5545 1f
                OUTS 5                   ; 5546 b5		;RAM addr
                LR   A,$b                ; 5547 4b
                LR   (IS),A              ; 5548 5c
                OUTS 4                   ; 5549 b4		;RAM data
                LIS  $f                  ; 554a 7f
                OUTS 5                   ; 554b b5		;RAM addr
                LIS  $0                  ; 554c 70
                OUTS 4                   ; 554d b4		;RAM data
                LISU 7                   ; 554e 67
                LISL 3                   ; 554f 6b
A5550:          LIS  $2                  ; 5550 72
                AS   $2                  ; 5551 c2
                BT   2,A5526             ; 5552 82 d3
                JMP  A56fa               ; 5554 29 56 fa

A5557:          PI   A555b               ; 5557 28 55 5b
A555a:          OUTS 1                   ; 555a b1		;LED segments
A555b:          LI   $40                 ; 555b 20 40
                OUTS 4                   ; 555d b4		;RAM data
A555e:          INS  4                   ; 555e a4			;RAM data
                BT   1,A555e             ; 555f 81 fe
                LIS  $0                  ; 5561 70
A5562:          OUTS 4                   ; 5562 b4		;RAM data
                OUTS 5                   ; 5563 b5		;RAM addr
                OUTS 1                   ; 5564 b1		;LED segments
A5565:          INS  4                   ; 5565 a4			;RAM data
                BF   $1,A5565            ; 5566 91 fe
                SR   4                   ; 5568 14
                BF   $4,A5573            ; 5569 94 09
A556b:          INS  5                   ; 556b a5			;RAM addr
                LR   IS,A                ; 556c 0b
A556d:          LR   A,(IS)              ; 556d 4c
                BT   1,A555a             ; 556e 81 eb
                INS  1                   ; 5570 a1			;LED segments
                LR   (IS),A              ; 5571 5c
                POP                      ; 5572 1c

A5573:          INS  5                   ; 5573 a5			;RAM addr
                LR   QL,A                ; 5574 07
                INS  4                   ; 5575 a4			;RAM data
                LR   QU,A                ; 5576 06
                SL   1                   ; 5577 13
A5578:          SL   1                   ; 5578 13
                BF   $1,A557d            ; 5579 91 03
                INS  1                   ; 557b a1			;LED segments
                LR   P0,Q                ; 557c 0d

A557d:          XDC                      ; 557d 2c
                LR   DC,Q                ; 557e 0f
                LM                       ; 557f 16
                POP                      ; 5580 1c

;high nybble is piece: black 9=pawn, a=knight, b=bishop, c=rook, d=queen, e=king
;high nybble is piece: white 7=pawn, 6=knight, 5=bishop, 4=rook, 3=queen, 2=king
;low nybble is square value

A5581:		db   $c1,$a1,$b2,$d2,$e2,$b2,$a1,$c1
                db   $91,$92,$93,$93,$93,$93,$92,$91
                db   $82,$83,$84,$85,$85,$84,$83,$82
                db   $82,$83,$85,$85,$85,$85,$83,$82
                db   $82,$83,$85,$85,$85,$85,$83,$82
                db   $82,$83,$84,$85,$85,$84,$83,$82
                db   $71,$72,$73,$73,$73,$73,$72,$71
                db   $41,$61,$52,$32,$22,$52,$61,$41

A55C1:          db   $f0,$e0,$c0,$a0,$90,$c0,$bf,$ae
                db   $10,$9c,$6b,$6a,$c0,$58,$47,$16
                db   $99,$90,$09,$09,$09,$09,$99,$95
                db   $93,$91,$59,$55,$53,$51,$39,$35
                db   $33,$31,$19,$15,$13,$11
                db   $90,$90,$90,$90,$54,$50,$50,$50
                db   $36,$32,$30,$30,$18,$14,$12,$10

;where does data end and code begin?
                db   $09,$45,$63,$81,$09,$05,$23,$41
;                LR   P,K                 ; 55f7 09
;                LR   A,$5                ; 55f8 45
;                LISU 3                   ; 55f9 63
;                BT   1,A5604             ; 55fa 81 09
;                LR   KL,A                ; 55fc 05
;                XI   $41                 ; 55fd 23 41

                LR   P,K                 ; 55ff 09
                LR   KL,A                ; 5600 05
                LR   A,QL                ; 5601 03
                NI   $09                 ; 5602 21 09
A5604:          LR   KL,A                ; 5604 05
                LR   A,QL                ; 5605 03
                LR   A,KL                ; 5606 01
                LR   A,$4                ; 5607 44
                SL   4                   ; 5608 15
                AS   $a                  ; 5609 ca
                LR   $b,A                ; 560a 5b
                DS   $b                  ; 560b 3b
                LR   A,$0                ; 560c 40
                SL   1                   ; 560d 13
                LIS  $0                  ; 560e 70
                BF   $1,A566c            ; 560f 91 5c
                LR   A,$b                ; 5611 4b
                OUTS 5                   ; 5612 b5		;RAM addr
                INS  4                   ; 5613 a4			;RAM data
                BT   4,A5618             ; 5614 84 03
                LIS  $0                  ; 5616 70
                PK                       ; 5617 0c

A5618:          LIS  $2                  ; 5618 72
                AS   $b                  ; 5619 cb
                LR   $b,A                ; 561a 5b
                OUTS 5                   ; 561b b5		;RAM addr
                INS  4                   ; 561c a4			;RAM data
                BT   4,A5621             ; 561d 84 03
                LIS  $0                  ; 561f 70
                PK                       ; 5620 0c

A5621:          LR   A,IS                ; 5621 0a
                LR   QL,A                ; 5622 07
                INC                      ; 5623 1f
                DI                       ; 5624 1a
                LR   IS,A                ; 5625 0b
                LR   A,(IS)+             ; 5626 4d
                NI   $77                 ; 5627 21 77
                LR   $5,A                ; 5629 55
                LR   A,(IS)              ; 562a 4c
                NI   $77                 ; 562b 21 77
                OUTS 5                   ; 562d b5		;RAM addr
                AS   $5                  ; 562e c5
                SR   1                   ; 562f 12
                LR   $5,A                ; 5630 55
                LR   A,QL                ; 5631 03
                EI                       ; 5632 1b
                LR   IS,A                ; 5633 0b
                INS  4                   ; 5634 a4			;RAM data
                AS   $4                  ; 5635 c4
A5636:          BF   $4,A5641            ; 5636 94 0a
                LR   A,$b                ; 5638 4b
                COM                      ; 5639 18
                AS   $5                  ; 563a c5
                CI   $fc                 ; 563b 25 fc
                BT   2,A5641             ; 563d 82 03
                INC                      ; 563f 1f
                PK                       ; 5640 0c

A5641:          LR   A,$4                ; 5641 44
                SL   4                   ; 5642 15
                AS   $a                  ; 5643 ca
                LR   $b,A                ; 5644 5b
                OUTS 5                   ; 5645 b5		;RAM addr
                INS  4                   ; 5646 a4			;RAM data
                BF   $4,A566f            ; 5647 94 27
                PK                       ; 5649 0c

                LR   A,$4                ; 564a 44
                SL   4                   ; 564b 15
                AS   $b                  ; 564c cb
                LR   $b,A                ; 564d 5b
                OUTS 5                   ; 564e b5		;RAM addr
                XS   $4                  ; 564f e4
                SL   1                   ; 5650 13
                BF   $1,A566f            ; 5651 91 1d
                INS  4                   ; 5653 a4			;RAM data
                BF   $4,A566f            ; 5654 94 1a
                PK                       ; 5656 0c

                BF   $0,A566f            ; 5657 90 17		;bra

                NOP                      ; 5659 2b
                JMP  A533b               ; 565a 29 53 3b

                LI   $df                 ; 565d 20 df
                PK                       ; 565f 0c

                LIS  $2                  ; 5660 72
                PK                       ; 5661 0c

                LIS  $d                  ; 5662 7d
                PK                       ; 5663 0c

                LIS  $4                  ; 5664 74
                PK                       ; 5665 0c

                LI   $1c                 ; 5666 20 1c
                PK                       ; 5668 0c

                LIS  $4                  ; 5669 74
                PK                       ; 566a 0c

                LIS  $d                  ; 566b 7d
A566c:          PK                       ; 566c 0c

                LIS  $2                  ; 566d 72
                PK                       ; 566e 0c

A566f:          JMP  A534c               ; 566f 29 53 4c

                LIS  $f                  ; 5672 7f
                PK                       ; 5673 0c

                LIS  $1                  ; 5674 71
                PK                       ; 5675 0c

                LIS  $1                  ; 5676 71
                PK                       ; 5677 0c

                LI   $de                 ; 5678 20 de
                PK                       ; 567a 0c

                LIS  $1                  ; 567b 71
                PK                       ; 567c 0c

                LIS  $1                  ; 567d 71
                PK                       ; 567e 0c

                LIS  $e                  ; 567f 7e
                BF   $0,A566c            ; 5680 90 eb		;bra

A5682:          XS   $4                  ; 5682 e4
                LIS  $1                  ; 5683 71
                BT   1,A568f             ; 5684 81 0a
                NS   $4                  ; 5686 f4
                LI   $fe                 ; 5687 20 fe
                BT   4,A5693             ; 5689 84 09
                PK                       ; 568b 0c

                LIS  $4                  ; 568c 74
                BF   $0,A5693            ; 568d 90 05		;bra

A568f:          NS   $4                  ; 568f f4
                BF   $4,A5694            ; 5690 94 03
                LIS  $2                  ; 5692 72
A5693:          PK                       ; 5693 0c

A5694:          JMP  A5349               ; 5694 29 53 49

A5697:          LI   $f0                 ; 5697 20 f0
                PK                       ; 5699 0c

                BT   4,A5697             ; 569a 84 fc
                LR   A,$a                ; 569c 4a
                LR   $b,A                ; 569d 5b
A569e:          LI   $ff                 ; 569e 20 ff
                PK                       ; 56a0 0c

                BT   4,A569e             ; 56a1 84 fc
                LR   A,$a                ; 56a3 4a
                LR   $b,A                ; 56a4 5b
A56a5:          LIS  $1                  ; 56a5 71
                PK                       ; 56a6 0c

                BT   4,A56a5             ; 56a7 84 fd
                LR   A,$a                ; 56a9 4a
                LR   $b,A                ; 56aa 5b
A56ab:          LI   $10                 ; 56ab 20 10
                PK                       ; 56ad 0c

                BT   4,A56ab             ; 56ae 84 fc
                LIS  $1                  ; 56b0 71
                NS   $4                  ; 56b1 f4
                BT   4,A566f             ; 56b2 84 bc
                LR   A,$a                ; 56b4 4a
                LR   $b,A                ; 56b5 5b
A56b6:          LI   $ef                 ; 56b6 20 ef
                PK                       ; 56b8 0c

                BT   4,A56b6             ; 56b9 84 fc
                LR   A,$a                ; 56bb 4a
                LR   $b,A                ; 56bc 5b
A56bd:          LI   $f1                 ; 56bd 20 f1
                PK                       ; 56bf 0c

                BT   4,A56bd             ; 56c0 84 fc
                LR   A,$a                ; 56c2 4a
                LR   $b,A                ; 56c3 5b
A56c4:          LIS  $f                  ; 56c4 7f
                PK                       ; 56c5 0c

                BT   4,A56c4             ; 56c6 84 fd
                LR   A,$a                ; 56c8 4a
                LR   $b,A                ; 56c9 5b
A56ca:          LI   $11                 ; 56ca 20 11
                PK                       ; 56cc 0c

                BT   4,A56ca             ; 56cd 84 fc
                BF   $0,A566f            ; 56cf 90 9f		;bra

                LR   K,P                 ; 56d1 08
                AS   $b                  ; 56d2 cb
                LR   $b,A                ; 56d3 5b
                OUTS 5                   ; 56d4 b5		;RAM addr
                NI   $88                 ; 56d5 21 88
                BF   $4,A56fc            ; 56d7 94 24
                INS  4                   ; 56d9 a4			;RAM data
                LR   $5,A                ; 56da 55
                LR   A,$0                ; 56db 40
                SL   1                   ; 56dc 13
                BF   $1,A5705            ; 56dd 91 27
                LR   A,$5                ; 56df 45
                AS   $1                  ; 56e0 c1
                XS   $1                  ; 56e1 e1
                BF   $1,A56fe            ; 56e2 91 1b
                XS   $0                  ; 56e4 e0
                BF   $1,A56ea            ; 56e5 91 04
                JMP  A52c6               ; 56e7 29 52 c6

A56ea:          DI                       ; 56ea 1a
                LISU 2                   ; 56eb 62
                LISL 6                   ; 56ec 6e
                LR   A,(IS)+             ; 56ed 4d
                XS   $a                  ; 56ee ea
                BF   $4,A56f8            ; 56ef 94 08
                LR   A,(IS)-             ; 56f1 4e
                XS   $b                  ; 56f2 eb
                BF   $4,A56f8            ; 56f3 94 04
                JMP  A514d               ; 56f5 29 51 4d

A56f8:          LISU 7                   ; 56f8 67
                LISL 3                   ; 56f9 6b
A56fa:          LIS  $7                  ; 56fa 77
                NS   $5                  ; 56fb f5
A56fc:          LR   A,$3                ; 56fc 43
                LR   $9,A                ; 56fd 59
A56fe:          LI   $d1                 ; 56fe 20 d1
                DI                       ; 5700 1a
                LR   P,K                 ; 5701 09
                LR   KL,A                ; 5702 05
                EI                       ; 5703 1b
                POP                      ; 5704 1c

A5705:          LIS  $5                  ; 5705 75
                AS   $5                  ; 5706 c5
                CI   $0a                 ; 5707 25 0a
                BT   2,A5728             ; 5709 82 1e
                XS   $4                  ; 570b e4
                BT   1,A56fc             ; 570c 81 ef
                LR   A,$5                ; 570e 45
                XS   $1                  ; 570f e1
                BF   $1,A5717            ; 5710 91 06
                LIS  $0                  ; 5712 70
                LR   $3,A                ; 5713 53
                JMP  A546a               ; 5714 29 54 6a

A5717:          LIS  $1                  ; 5717 71
                LR   $2,A                ; 5718 52
                LR   A,IS                ; 5719 0a
                LR   QL,A                ; 571a 07
                AI   $c1                 ; 571b 24 c1
                BT   2,A5728             ; 571d 82 0a
                DI                       ; 571f 1a
                LR   IS,A                ; 5720 0b
                LR   A,(IS)              ; 5721 4c
                OI   $80                 ; 5722 22 80
                LR   (IS),A              ; 5724 5c
                LR   A,QL                ; 5725 03
                EI                       ; 5726 1b
                LR   IS,A                ; 5727 0b
A5728:          LIS  $8                  ; 5728 78
                AS   $b                  ; 5729 cb
                OUTS 5                   ; 572a b5		;RAM addr
                INS  4                   ; 572b a4			;RAM data
                LR   QL,A                ; 572c 07
                LIS  $0                  ; 572d 70
                XS   $4                  ; 572e e4
                LR   A,QL                ; 572f 03
                BF   $1,A573b            ; 5730 91 0a
                AI   $40                 ; 5732 24 40
                BT   2,A5737             ; 5734 82 02
                LR   QL,A                ; 5736 07
A5737:          NI   $0c                 ; 5737 21 0c
                BF   $0,A5746            ; 5739 90 0c		;bra

A573b:          OI   $cf                 ; 573b 22 cf
                COM                      ; 573d 18
                LR   A,QL                ; 573e 03
                BT   4,A5744             ; 573f 84 04
                AI   $10                 ; 5741 24 10
                LR   QL,A                ; 5743 07
A5744:          NI   $03                 ; 5744 21 03
A5746:          AS   $9                  ; 5746 c9
                COM                      ; 5747 18
A5748:          DI                       ; 5748 1a
                LR   (IS),A              ; 5749 5c
                LR   A,QL                ; 574a 03
                BF   $1,A574e            ; 574b 91 02
                AS   (IS)                ; 574d cc
A574e:          OUTS 4                   ; 574e b4		;RAM data
                LI   $ff                 ; 574f 20 ff
                OUTS 5                   ; 5751 b5		;RAM addr
                LIS  $0                  ; 5752 70
A5753:          EI                       ; 5753 1b
                OUTS 4                   ; 5754 b4		;RAM data
                XS   $5                  ; 5755 e5
                BT   4,A56fe             ; 5756 84 a7
                LR   A,KL                ; 5758 01
                CI   $97                 ; 5759 25 97
                BT   2,A56fe             ; 575b 82 a2
                INS  5                   ; 575d a5			;RAM addr
                LR   $9,A                ; 575e 59
                XS   $4                  ; 575f e4
                BF   $1,A5766            ; 5760 91 05
                LR   A,$5                ; 5762 45
                COM                      ; 5763 18
                INC                      ; 5764 1f
                LR   $5,A                ; 5765 55
A5766:          LIS  $5                  ; 5766 75
                XS   $5                  ; 5767 e5
                BT   4,A56fe             ; 5768 84 95
                LR   A,KL                ; 576a 01
                CI   $b6                 ; 576b 25 b6
                LIS  $3                  ; 576d 73
                LNK                      ; 576e 19
                XS   $5                  ; 576f e5
                BT   4,A56fe             ; 5770 84 8d
                BF   $0,A56fc            ; 5772 90 89		;bra

                db   $f9,$f7,$fb,$fd,$fd			;what is this and how is it accessed?


A5779:          db   $ff,$00,$01,$03,$03,$05,$09,$07		;data table used at $5412
                db   $01,$01,$01,$01,$01,$02,$04,$09
                db   $ff,$ff,$ff,$ff,$ff,$fe,$fc,$f7

                db   $72,$ff,$97,$ff,$97,$fe,$b6,$fd
                db   $5d,$fd,$07,$fc

A579d:          db   $00,$00,$07,$f3,$5d,$f7,$b6,$f7		;jump table with data - $5600 data $00, $5607 data $f3, $565d data $f7, etc
                db   $97,$fb,$97,$ff,$72,$ff

;LED segment table inverted xGFEDCBA
A57ab:          db   $c0,$f9,$a4,$b0,$99,$92,$82,$f8,$80,$90	;0  1  2  3  4  5  6  7  8  9 (numbers)
                db   $f7,$fe,$c6,$8b,$ac,$ff			;_  -  C  h  ?  sp            (Ch means Boris checkmated you, ? means error)
                db   $ff,$92,$87,$c8,$87                        ;sp S  t  n  t                (St is stalemate and nt means you checkmated Boris)
                db   $88,$83,$c6,$a1,$86,$8e,$c2,$89		;A  b  C  d  E  F  G  H       (letters)
                db   $ff,$88,$c8,$9c,$d8,$9a,$dc		;K  Q  R  B  N  P             (Boris shapes for white pieces)
                db   $ff,$e3,$93,$c3,$a3,$c1,$81                ;K  Q  R  B  N  P             (Boris shapes for black pieces)

                db   $00,$00,$00,$00,$00,$00,$00,$00		;wasted bits
                db   $00,$00,$00,$00,$00,$00,$00,$00
                db   $00,$00,$00,$00,$00,$00,$00,$00
                db   $00,$00,$00,$00,$00,$00,$00,$00
                db   $00,$00,$00,$00,$00,$00,$00,$00
                db   $00,$00

